package com.ippon.pouet.common.infrastructure.primary;

import static org.assertj.core.api.Assertions.*;

import java.util.List;
import org.junit.jupiter.api.Test;

class PouetErrorUnitTest {

  @Test
  public void shouldGetErrorInformation() {
    PouetFieldError fieldError = PouetFieldErrorUnitTest.defaultFieldError();
    PouetError error = defaultError(fieldError);

    assertThat(error.getErrorType()).isEqualTo("type");
    assertThat(error.getMessage()).isEqualTo("message");
    assertThat(error.getFieldsErrors()).containsExactly(fieldError);
  }

  @Test
  public void shouldSerializeToJson() {
    assertThat(TestJson.writeAsString(defaultError(PouetFieldErrorUnitTest.defaultFieldError()))).isEqualTo(defaultJson());
  }

  @Test
  void shouldDeserializeFromJson() {
    assertThat(TestJson.readFromJson(defaultJson(), PouetError.class))
      .usingRecursiveComparison()
      .isEqualTo(defaultError(PouetFieldErrorUnitTest.defaultFieldError()));
  }

  private String defaultJson() {
    return "{\"errorType\":\"type\",\"message\":\"message\",\"fieldsErrors\":[" + PouetFieldErrorUnitTest.defaultJson() + "]}";
  }

  private PouetError defaultError(PouetFieldError fieldError) {
    return new PouetError("type", "message", List.of(fieldError));
  }
}
