package com.ippon.pouet.common.infrastructure.primary;

import static org.assertj.core.api.Assertions.*;

import org.junit.jupiter.api.Test;

class PouetFieldErrorUnitTest {

  @Test
  public void shouldGetFieldErrorInformation() {
    PouetFieldError fieldError = defaultFieldError();

    assertThat(fieldError.getFieldPath()).isEqualTo("path");
    assertThat(fieldError.getReason()).isEqualTo("reason");
    assertThat(fieldError.getMessage()).isEqualTo("message");
  }

  @Test
  public void shouldSerializeToJson() {
    assertThat(TestJson.writeAsString(defaultFieldError())).isEqualTo(defaultJson());
  }

  static PouetFieldError defaultFieldError() {
    return PouetFieldError.builder().fieldPath("path").reason("reason").message("message").build();
  }

  static String defaultJson() {
    return "{\"fieldPath\":\"path\",\"reason\":\"reason\",\"message\":\"message\"}";
  }
}
